import { Context } from "../services/context";
import { DataStoreFactory } from "../services/dataStore/factory";
import { FunctionConfig } from "../services/lambda";
import { UserPool } from "../services/userPoolService";
import { TokenConfig } from "../services/tokenGenerator";
import { KMSConfig } from "../services/crypto";
export declare type UserPoolDefaults = Omit<UserPool, "Id" | "CreationDate" | "LastModifiedDate">;
export interface Config {
    LambdaClient: AWS.Lambda.ClientConfiguration;
    TriggerFunctions: FunctionConfig;
    UserPoolDefaults: UserPoolDefaults;
    KMSConfig?: AWS.KMS.ClientConfiguration & KMSConfig;
    TokenConfig: TokenConfig;
}
export declare const DefaultConfig: Config;
export declare const loadConfig: (ctx: Context, dataStoreFactory: DataStoreFactory) => Promise<Config>;
