var __create = Object.create;
var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
var __markAsModule = (target) => __defProp(target, "__esModule", { value: true });
var __export = (target, all) => {
  __markAsModule(target);
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __reExport = (target, module2, desc) => {
  if (module2 && typeof module2 === "object" || typeof module2 === "function") {
    for (let key of __getOwnPropNames(module2))
      if (!__hasOwnProp.call(target, key) && key !== "default")
        __defProp(target, key, { get: () => module2[key], enumerable: !(desc = __getOwnPropDesc(module2, key)) || desc.enumerable });
  }
  return target;
};
var __toModule = (module2) => {
  return __reExport(__markAsModule(__defProp(module2 != null ? __create(__getProtoOf(module2)) : {}, "default", module2 && module2.__esModule && "default" in module2 ? { get: () => module2.default, enumerable: true } : { value: module2, enumerable: true })), module2);
};
__export(exports, {
  CognitoServiceFactoryImpl: () => CognitoServiceFactoryImpl,
  CognitoServiceImpl: () => CognitoServiceImpl,
  USER_POOL_AWS_DEFAULTS: () => USER_POOL_AWS_DEFAULTS
});
var import_lodash = __toModule(require("lodash.mergewith"));
var path = __toModule(require("path"));
var import_errors = __toModule(require("../errors"));
var import_promises = __toModule(require("fs/promises"));
const CLIENTS_DATABASE_NAME = "clients";
const USER_POOL_AWS_DEFAULTS = {
  Policies: {
    PasswordPolicy: {
      MinimumLength: 8,
      RequireUppercase: true,
      RequireLowercase: true,
      RequireNumbers: true,
      RequireSymbols: true,
      TemporaryPasswordValidityDays: 7
    }
  },
  LambdaConfig: {},
  SchemaAttributes: [
    {
      Name: "sub",
      AttributeDataType: "String",
      DeveloperOnlyAttribute: false,
      Mutable: false,
      Required: true,
      StringAttributeConstraints: {
        MinLength: "1",
        MaxLength: "2048"
      }
    },
    {
      Name: "name",
      AttributeDataType: "String",
      DeveloperOnlyAttribute: false,
      Mutable: true,
      Required: false,
      StringAttributeConstraints: {
        MinLength: "0",
        MaxLength: "2048"
      }
    },
    {
      Name: "given_name",
      AttributeDataType: "String",
      DeveloperOnlyAttribute: false,
      Mutable: true,
      Required: false,
      StringAttributeConstraints: {
        MinLength: "0",
        MaxLength: "2048"
      }
    },
    {
      Name: "family_name",
      AttributeDataType: "String",
      DeveloperOnlyAttribute: false,
      Mutable: true,
      Required: false,
      StringAttributeConstraints: {
        MinLength: "0",
        MaxLength: "2048"
      }
    },
    {
      Name: "middle_name",
      AttributeDataType: "String",
      DeveloperOnlyAttribute: false,
      Mutable: true,
      Required: false,
      StringAttributeConstraints: {
        MinLength: "0",
        MaxLength: "2048"
      }
    },
    {
      Name: "nickname",
      AttributeDataType: "String",
      DeveloperOnlyAttribute: false,
      Mutable: true,
      Required: false,
      StringAttributeConstraints: {
        MinLength: "0",
        MaxLength: "2048"
      }
    },
    {
      Name: "preferred_username",
      AttributeDataType: "String",
      DeveloperOnlyAttribute: false,
      Mutable: true,
      Required: false,
      StringAttributeConstraints: {
        MinLength: "0",
        MaxLength: "2048"
      }
    },
    {
      Name: "profile",
      AttributeDataType: "String",
      DeveloperOnlyAttribute: false,
      Mutable: true,
      Required: false,
      StringAttributeConstraints: {
        MinLength: "0",
        MaxLength: "2048"
      }
    },
    {
      Name: "picture",
      AttributeDataType: "String",
      DeveloperOnlyAttribute: false,
      Mutable: true,
      Required: false,
      StringAttributeConstraints: {
        MinLength: "0",
        MaxLength: "2048"
      }
    },
    {
      Name: "website",
      AttributeDataType: "String",
      DeveloperOnlyAttribute: false,
      Mutable: true,
      Required: false,
      StringAttributeConstraints: {
        MinLength: "0",
        MaxLength: "2048"
      }
    },
    {
      Name: "email",
      AttributeDataType: "String",
      DeveloperOnlyAttribute: false,
      Mutable: true,
      Required: false,
      StringAttributeConstraints: {
        MinLength: "0",
        MaxLength: "2048"
      }
    },
    {
      Name: "email_verified",
      AttributeDataType: "Boolean",
      DeveloperOnlyAttribute: false,
      Mutable: true,
      Required: false
    },
    {
      Name: "gender",
      AttributeDataType: "String",
      DeveloperOnlyAttribute: false,
      Mutable: true,
      Required: false,
      StringAttributeConstraints: {
        MinLength: "0",
        MaxLength: "2048"
      }
    },
    {
      Name: "birthdate",
      AttributeDataType: "String",
      DeveloperOnlyAttribute: false,
      Mutable: true,
      Required: false,
      StringAttributeConstraints: {
        MinLength: "10",
        MaxLength: "10"
      }
    },
    {
      Name: "zoneinfo",
      AttributeDataType: "String",
      DeveloperOnlyAttribute: false,
      Mutable: true,
      Required: false,
      StringAttributeConstraints: {
        MinLength: "0",
        MaxLength: "2048"
      }
    },
    {
      Name: "locale",
      AttributeDataType: "String",
      DeveloperOnlyAttribute: false,
      Mutable: true,
      Required: false,
      StringAttributeConstraints: {
        MinLength: "0",
        MaxLength: "2048"
      }
    },
    {
      Name: "phone_number",
      AttributeDataType: "String",
      DeveloperOnlyAttribute: false,
      Mutable: true,
      Required: false,
      StringAttributeConstraints: {
        MinLength: "0",
        MaxLength: "2048"
      }
    },
    {
      Name: "phone_number_verified",
      AttributeDataType: "Boolean",
      DeveloperOnlyAttribute: false,
      Mutable: true,
      Required: false
    },
    {
      Name: "address",
      AttributeDataType: "String",
      DeveloperOnlyAttribute: false,
      Mutable: true,
      Required: false,
      StringAttributeConstraints: {
        MinLength: "0",
        MaxLength: "2048"
      }
    },
    {
      Name: "updated_at",
      AttributeDataType: "Number",
      DeveloperOnlyAttribute: false,
      Mutable: true,
      Required: false,
      NumberAttributeConstraints: {
        MinValue: "0"
      }
    }
  ],
  VerificationMessageTemplate: {
    DefaultEmailOption: "CONFIRM_WITH_CODE"
  },
  MfaConfiguration: "OFF",
  EstimatedNumberOfUsers: 0,
  EmailConfiguration: {
    EmailSendingAccount: "COGNITO_DEFAULT"
  },
  AdminCreateUserConfig: {
    AllowAdminCreateUserOnly: false,
    UnusedAccountValidityDays: 7
  }
};
class CognitoServiceImpl {
  constructor(dataDirectory, clients, clock, userPoolDefaultConfig, userPoolServiceFactory) {
    this.clients = clients;
    this.clock = clock;
    this.dataDirectory = dataDirectory;
    this.userPoolDefaultConfig = userPoolDefaultConfig;
    this.userPoolServiceFactory = userPoolServiceFactory;
  }
  async createUserPool(ctx, userPool) {
    ctx.logger.debug("CognitoServiceImpl.createUserPool");
    const service = await this.userPoolServiceFactory.create(ctx, this.clients, (0, import_lodash.default)({}, USER_POOL_AWS_DEFAULTS, this.userPoolDefaultConfig, userPool));
    return service.options;
  }
  async deleteUserPool(ctx, userPool) {
    ctx.logger.debug({ userPoolId: userPool.Id }, "CognitoServiceImpl.deleteUserPool");
    await import_promises.default.rm(path.join(this.dataDirectory, `${userPool.Id}.json`));
  }
  async getUserPool(ctx, userPoolId) {
    ctx.logger.debug({ userPoolId }, "CognitoServiceImpl.getUserPool");
    return this.userPoolServiceFactory.create(ctx, this.clients, __spreadProps(__spreadValues(__spreadValues({}, USER_POOL_AWS_DEFAULTS), this.userPoolDefaultConfig), {
      Id: userPoolId
    }));
  }
  async getUserPoolForClientId(ctx, clientId) {
    ctx.logger.debug({ clientId }, "CognitoServiceImpl.getUserPoolForClientId");
    const appClient = await this.getAppClient(ctx, clientId);
    if (!appClient) {
      throw new import_errors.ResourceNotFoundError();
    }
    return this.userPoolServiceFactory.create(ctx, this.clients, __spreadProps(__spreadValues(__spreadValues({}, USER_POOL_AWS_DEFAULTS), this.userPoolDefaultConfig), {
      Id: appClient.UserPoolId
    }));
  }
  async getAppClient(ctx, clientId) {
    ctx.logger.debug({ clientId }, "CognitoServiceImpl.getAppClient");
    return this.clients.get(ctx, ["Clients", clientId]);
  }
  async listAppClients(ctx, userPoolId) {
    ctx.logger.debug({ userPoolId }, "CognitoServiceImpl.listAppClients");
    const clients = await this.clients.get(ctx, "Clients", {});
    return Object.values(clients).filter((x) => x.UserPoolId === userPoolId);
  }
  async listUserPools(ctx) {
    ctx.logger.debug("CognitoServiceImpl.listUserPools");
    const entries = await import_promises.default.readdir(this.dataDirectory, {
      withFileTypes: true
    });
    return Promise.all(entries.filter((x) => x.isFile() && path.extname(x.name) === ".json" && path.basename(x.name, path.extname(x.name)) !== CLIENTS_DATABASE_NAME).map(async (x) => {
      const userPool = await this.getUserPool(ctx, path.basename(x.name, path.extname(x.name)));
      return userPool.options;
    }));
  }
}
class CognitoServiceFactoryImpl {
  constructor(dataDirectory, clock, dataStoreFactory, userPoolServiceFactory) {
    this.dataDirectory = dataDirectory;
    this.clock = clock;
    this.dataStoreFactory = dataStoreFactory;
    this.userPoolServiceFactory = userPoolServiceFactory;
  }
  async create(ctx, userPoolDefaultConfig) {
    const clients = await this.dataStoreFactory.create(ctx, CLIENTS_DATABASE_NAME, { Clients: {} });
    return new CognitoServiceImpl(this.dataDirectory, clients, this.clock, userPoolDefaultConfig, this.userPoolServiceFactory);
  }
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  CognitoServiceFactoryImpl,
  CognitoServiceImpl,
  USER_POOL_AWS_DEFAULTS
});
