import StormDB from "stormdb";
import { Context } from "../context";
import { DataStoreCache } from "./cache";
import { DataStore } from "./dataStore";
import { DataStoreFactory } from "./factory";
export declare class StormDBDataStore implements DataStore {
    private readonly db;
    constructor(db: StormDB);
    delete(ctx: Context, key: string | string[]): Promise<void>;
    getRoot(ctx: Context): Promise<any>;
    get<T>(ctx: Context, key: string | string[], defaultValue?: T): Promise<any>;
    set<T>(ctx: Context, key: string | string[], value: T): Promise<void>;
}
export declare class StormDBDataStoreFactory implements DataStoreFactory {
    private readonly directory;
    private readonly cache;
    constructor(directory: string, dataStoreCache: DataStoreCache);
    create(ctx: Context, id: string, defaults: object): Promise<DataStore>;
}
