declare type Matcher<T> = (obj: T, filterType: "=" | "^=", value: string) => boolean;
declare type FieldLookup<T> = (obj: T) => string | boolean | undefined;
export declare class FilterConfig<T> {
    #private;
    static caseSensitive<T>(field: FieldLookup<T>): Matcher<T>;
    static caseInsensitive<T>(field: FieldLookup<T>): Matcher<T>;
    constructor(fields: Record<string, Matcher<T>>);
    parse(filter: string | undefined): (obj: T) => boolean;
}
export {};
