var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __markAsModule = (target) => __defProp(target, "__esModule", { value: true });
var __export = (target, all) => {
  __markAsModule(target);
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __reExport = (target, module2, desc) => {
  if (module2 && typeof module2 === "object" || typeof module2 === "function") {
    for (let key of __getOwnPropNames(module2))
      if (!__hasOwnProp.call(target, key) && key !== "default")
        __defProp(target, key, { get: () => module2[key], enumerable: !(desc = __getOwnPropDesc(module2, key)) || desc.enumerable });
  }
  return target;
};
var __toModule = (module2) => {
  return __reExport(__markAsModule(__defProp(module2 != null ? __create(__getProtoOf(module2)) : {}, "default", module2 && module2.__esModule && "default" in module2 ? { get: () => module2.default, enumerable: true } : { value: module2, enumerable: true })), module2);
};
var __accessCheck = (obj, member, msg) => {
  if (!member.has(obj))
    throw TypeError("Cannot " + msg);
};
var __privateGet = (obj, member, getter) => {
  __accessCheck(obj, member, "read from private field");
  return getter ? getter.call(obj) : member.get(obj);
};
var __privateAdd = (obj, member, value) => {
  if (member.has(obj))
    throw TypeError("Cannot add the same private member more than once");
  member instanceof WeakSet ? member.add(obj) : member.set(obj, value);
};
var __privateSet = (obj, member, value, setter) => {
  __accessCheck(obj, member, "write to private field");
  setter ? setter.call(obj, value) : member.set(obj, value);
  return value;
};
__export(exports, {
  FilterConfig: () => FilterConfig
});
var import_errors = __toModule(require("../errors"));
var _fields;
const FilterExpression = new RegExp(/^\s*(?<attr>.*)\s+(?<type>\^?=)\s+"(?<value>.*)"\s*$/);
function compare(fieldValue, type, value) {
  return type === "=" ? fieldValue === value : (fieldValue == null ? void 0 : fieldValue.startsWith(value)) ?? false;
}
class FilterConfig {
  constructor(fields) {
    __privateAdd(this, _fields, void 0);
    __privateSet(this, _fields, fields);
  }
  static caseSensitive(field) {
    return (obj, type, value) => {
      var _a;
      return compare((_a = field(obj)) == null ? void 0 : _a.toString(), type, value);
    };
  }
  static caseInsensitive(field) {
    return (obj, type, value) => {
      var _a, _b;
      return compare((_b = (_a = field(obj)) == null ? void 0 : _a.toString()) == null ? void 0 : _b.toLocaleLowerCase(), type, value.toLocaleLowerCase());
    };
  }
  parse(filter) {
    if (!filter) {
      return () => true;
    }
    const match = FilterExpression.exec(filter);
    if (!(match == null ? void 0 : match.groups)) {
      throw new import_errors.InvalidParameterError("Error while parsing filter");
    }
    const { attr, type, value } = match.groups;
    if (type !== "=" && type !== "^=") {
      throw new import_errors.InvalidParameterError("Error while parsing filter");
    }
    const field = __privateGet(this, _fields)[attr];
    if (!field) {
      throw new import_errors.InvalidParameterError(`Invalid search attribute: ${attr}`);
    }
    return (obj) => field(obj, type, value);
  }
}
_fields = new WeakMap();
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  FilterConfig
});
