import { Context } from "../context";
import { Message } from "../messages";
import { User } from "../userPoolService";
import { MessageSender } from "./messageSender";
export declare type DeliveryDetails = {
    AttributeName: "email";
    DeliveryMedium: "EMAIL";
    Destination: string;
} | {
    AttributeName: "phone_number";
    DeliveryMedium: "SMS";
    Destination: string;
};
export interface MessageDelivery {
    deliver(ctx: Context, user: User, deliveryDetails: DeliveryDetails, message: Message): Promise<void>;
}
export declare class MessageDeliveryService implements MessageDelivery {
    private readonly sender;
    constructor(sender: MessageSender);
    deliver(ctx: Context, user: User, deliveryDetails: DeliveryDetails, message: Message): Promise<void>;
}
