var __defProp = Object.defineProperty;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __markAsModule = (target) => __defProp(target, "__esModule", { value: true });
var __export = (target, all) => {
  __markAsModule(target);
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
__export(exports, {
  MessagesService: () => MessagesService
});
const AWS_ADMIN_CLIENT_ID = "CLIENT_ID_NOT_APPLICABLE";
class MessagesService {
  constructor(triggers, messageDelivery) {
    this.triggers = triggers;
    this.messageDelivery = messageDelivery;
  }
  async deliver(ctx, source, clientId, userPoolId, user, code, clientMetadata, deliveryDetails) {
    if (this.triggers.enabled("CustomEmailSender") && source !== "Authentication") {
      return this.customDelivery(ctx, source, clientId, userPoolId, user, code, clientMetadata);
    }
    const message = await this.create(ctx, source, clientId, userPoolId, user, code, clientMetadata);
    await this.messageDelivery.deliver(ctx, user, deliveryDetails, message);
  }
  async create(ctx, source, clientId, userPoolId, user, code, clientMetadata) {
    if (this.triggers.enabled("CustomMessage")) {
      const message = await this.triggers.customMessage(ctx, {
        clientId: clientId ?? AWS_ADMIN_CLIENT_ID,
        clientMetadata,
        code,
        source: `CustomMessage_${source}`,
        userAttributes: user.Attributes,
        username: user.Username,
        userPoolId
      });
      return __spreadValues({
        __code: code
      }, message);
    }
    return {
      __code: code
    };
  }
  async customDelivery(ctx, source, clientId, userPoolId, user, code, clientMetadata) {
    await this.triggers.customEmailSender(ctx, {
      clientId: clientId ?? AWS_ADMIN_CLIENT_ID,
      clientMetadata,
      code,
      source: `CustomEmailSender_${source}`,
      userAttributes: user.Attributes,
      username: user.Username,
      userPoolId
    });
  }
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  MessagesService
});
