import { AppClient } from "./appClient";
import { Clock } from "./clock";
import { Context } from "./context";
import { Triggers } from "./triggers";
import { User } from "./userPoolService";
export interface TokenConfig {
    IssuerDomain?: string;
}
export interface Token {
    client_id: string;
    iss: string;
    sub: string;
    token_use: string;
    username: string;
    event_id: string;
    scope: string;
    auth_time: Date;
    jti: string;
}
export interface Tokens {
    readonly AccessToken: string;
    readonly IdToken: string;
    readonly RefreshToken: string;
}
export interface TokenGenerator {
    generate(ctx: Context, user: User, userGroups: readonly string[], userPoolClient: AppClient, clientMetadata: Record<string, string> | undefined, source: "AuthenticateDevice" | "Authentication" | "HostedAuth" | "NewPasswordChallenge" | "RefreshTokens"): Promise<Tokens>;
}
export declare class JwtTokenGenerator implements TokenGenerator {
    private readonly clock;
    private readonly triggers;
    private readonly tokenConfig;
    constructor(clock: Clock, triggers: Triggers, tokenConfig: TokenConfig);
    generate(ctx: Context, user: User, userGroups: readonly string[], userPoolClient: AppClient, clientMetadata: Record<string, string> | undefined, source: "AuthenticateDevice" | "Authentication" | "HostedAuth" | "NewPasswordChallenge" | "RefreshTokens"): Promise<Tokens>;
}
