var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __markAsModule = (target) => __defProp(target, "__esModule", { value: true });
var __export = (target, all) => {
  __markAsModule(target);
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __reExport = (target, module2, desc) => {
  if (module2 && typeof module2 === "object" || typeof module2 === "function") {
    for (let key of __getOwnPropNames(module2))
      if (!__hasOwnProp.call(target, key) && key !== "default")
        __defProp(target, key, { get: () => module2[key], enumerable: !(desc = __getOwnPropDesc(module2, key)) || desc.enumerable });
  }
  return target;
};
var __toModule = (module2) => {
  return __reExport(__markAsModule(__defProp(module2 != null ? __create(__getProtoOf(module2)) : {}, "default", module2 && module2.__esModule && "default" in module2 ? { get: () => module2.default, enumerable: true } : { value: module2, enumerable: true })), module2);
};
__export(exports, {
  CustomMessage: () => CustomMessage
});
var import_userPoolService = __toModule(require("../userPoolService"));
const AWS_USERNAME_PARAMETER = "{username}";
const AWS_CODE_PARAMETER = "{####}";
const CustomMessage = ({ lambda }) => async (ctx, {
  clientId,
  clientMetadata,
  code,
  source,
  userAttributes,
  username,
  userPoolId
}) => {
  var _a, _b;
  try {
    const response = await lambda.invoke(ctx, "CustomMessage", {
      clientId,
      clientMetadata,
      codeParameter: AWS_CODE_PARAMETER,
      triggerSource: source,
      userAttributes: (0, import_userPoolService.attributesToRecord)(userAttributes),
      username,
      usernameParameter: AWS_USERNAME_PARAMETER,
      userPoolId
    });
    return {
      emailMessage: (_a = response.emailMessage) == null ? void 0 : _a.replace(AWS_CODE_PARAMETER, code).replace(AWS_USERNAME_PARAMETER, username),
      emailSubject: response.emailSubject,
      smsMessage: (_b = response.smsMessage) == null ? void 0 : _b.replace(AWS_CODE_PARAMETER, code).replace(AWS_USERNAME_PARAMETER, username)
    };
  } catch (ex) {
    ctx.logger.error(ex);
    return null;
  }
};
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  CustomMessage
});
