import { AttributeListType } from "aws-sdk/clients/cognitoidentityserviceprovider";
import { Lambda } from "../lambda";
import { Trigger } from "./trigger";
export declare type PostAuthenticationTrigger = Trigger<{
    clientId: string;
    /**
     * One or more key-value pairs that you can provide as custom input to the Lambda function that you specify for the
     * post authentication trigger. You can pass this data to your Lambda function by using the ClientMetadata parameter
     * in the AdminRespondToAuthChallenge and RespondToAuthChallenge API actions.
     *
     * Source: https://docs.aws.amazon.com/cognito/latest/developerguide/user-pool-lambda-post-authentication.html
     */
    clientMetadata: Record<string, string> | undefined;
    source: "PostAuthentication_Authentication";
    userAttributes: AttributeListType;
    username: string;
    userPoolId: string;
}, void>;
declare type PostAuthenticationServices = {
    lambda: Lambda;
};
export declare const PostAuthentication: ({ lambda }: PostAuthenticationServices) => PostAuthenticationTrigger;
export {};
