import { Clock } from "../clock";
import { CognitoService } from "../cognitoService";
import { CryptoService } from "../crypto";
import { Lambda } from "../lambda";
import { CustomEmailSenderTrigger } from "./customEmailSender";
import { CustomMessageTrigger } from "./customMessage";
import { PostAuthenticationTrigger } from "./postAuthentication";
import { PostConfirmationTrigger } from "./postConfirmation";
import { PreSignUpTrigger } from "./preSignUp";
import { PreTokenGenerationTrigger } from "./preTokenGeneration";
import { UserMigrationTrigger } from "./userMigration";
declare type SupportedTriggers = "CustomEmailSender" | "CustomMessage" | "UserMigration" | "PostAuthentication" | "PostConfirmation" | "PreSignUp" | "PreTokenGeneration";
export interface Triggers {
    enabled(trigger: SupportedTriggers): boolean;
    customMessage: CustomMessageTrigger;
    customEmailSender: CustomEmailSenderTrigger;
    postAuthentication: PostAuthenticationTrigger;
    postConfirmation: PostConfirmationTrigger;
    preSignUp: PreSignUpTrigger;
    preTokenGeneration: PreTokenGenerationTrigger;
    userMigration: UserMigrationTrigger;
}
export declare class TriggersService implements Triggers {
    private readonly lambda;
    readonly customMessage: CustomMessageTrigger;
    readonly customEmailSender: CustomEmailSenderTrigger;
    readonly postAuthentication: PostAuthenticationTrigger;
    readonly postConfirmation: PostConfirmationTrigger;
    readonly preSignUp: PreSignUpTrigger;
    readonly preTokenGeneration: PreTokenGenerationTrigger;
    readonly userMigration: UserMigrationTrigger;
    constructor(clock: Clock, cognitoClient: CognitoService, lambda: Lambda, crypto: CryptoService);
    enabled(trigger: SupportedTriggers): boolean;
}
export {};
