var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __markAsModule = (target) => __defProp(target, "__esModule", { value: true });
var __export = (target, all) => {
  __markAsModule(target);
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __reExport = (target, module2, desc) => {
  if (module2 && typeof module2 === "object" || typeof module2 === "function") {
    for (let key of __getOwnPropNames(module2))
      if (!__hasOwnProp.call(target, key) && key !== "default")
        __defProp(target, key, { get: () => module2[key], enumerable: !(desc = __getOwnPropDesc(module2, key)) || desc.enumerable });
  }
  return target;
};
var __toModule = (module2) => {
  return __reExport(__markAsModule(__defProp(module2 != null ? __create(__getProtoOf(module2)) : {}, "default", module2 && module2.__esModule && "default" in module2 ? { get: () => module2.default, enumerable: true } : { value: module2, enumerable: true })), module2);
};
__export(exports, {
  UserMigration: () => UserMigration
});
var uuid = __toModule(require("uuid"));
var import_errors = __toModule(require("../../errors"));
var import_userPoolService = __toModule(require("../userPoolService"));
const UserMigration = ({
  lambda,
  cognitoClient,
  clock
}) => async (ctx, {
  clientId,
  clientMetadata,
  password,
  userAttributes,
  username,
  userPoolId,
  validationData
}) => {
  var _a;
  const userPool = await cognitoClient.getUserPoolForClientId(ctx, clientId);
  if (!userPool) {
    throw new import_errors.ResourceNotFoundError();
  }
  let result;
  try {
    result = await lambda.invoke(ctx, "UserMigration", {
      clientId,
      clientMetadata,
      password,
      triggerSource: "UserMigration_Authentication",
      userAttributes: (0, import_userPoolService.attributesToRecord)(userAttributes),
      username,
      userPoolId,
      validationData
    });
  } catch (ex) {
    throw new import_errors.NotAuthorizedError();
  }
  const now = clock.get();
  const user = {
    Attributes: (0, import_userPoolService.attributesFromRecord)(result.userAttributes ?? {}),
    Enabled: true,
    Password: password,
    UserCreateDate: now,
    UserLastModifiedDate: now,
    Username: ((_a = result.userAttributes) == null ? void 0 : _a.username) || uuid.v4(),
    UserStatus: result.finalUserStatus ?? "CONFIRMED",
    RefreshTokens: []
  };
  if (result.forceAliasCreation) {
  }
  await userPool.saveUser(ctx, user);
  if (result.messageAction !== "SUPPRESS") {
  }
  return user;
};
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  UserMigration
});
