import { Context } from "../services/context";
import { Targets } from "./targets";
export declare type TargetName = keyof typeof Targets;
export declare type Target<Req extends {}, Res extends {}> = (ctx: Context, req: Req) => Promise<Res>;
export declare const isSupportedTarget: (name: string) => name is "SignUp" | "ForgotPassword" | "AdminCreateUser" | "VerifyUserAttribute" | "AddCustomAttributes" | "AdminAddUserToGroup" | "AdminConfirmSignUp" | "AdminDeleteUser" | "AdminDeleteUserAttributes" | "AdminDisableUser" | "AdminEnableUser" | "AdminGetUser" | "AdminInitiateAuth" | "AdminListGroupsForUser" | "AdminRemoveUserFromGroup" | "AdminSetUserPassword" | "AdminUpdateUserAttributes" | "ChangePassword" | "ConfirmForgotPassword" | "ConfirmSignUp" | "CreateGroup" | "CreateUserPool" | "CreateUserPoolClient" | "DeleteGroup" | "DeleteUser" | "DeleteUserAttributes" | "DeleteUserPool" | "DeleteUserPoolClient" | "DescribeUserPool" | "DescribeUserPoolClient" | "GetGroup" | "GetUser" | "GetUserAttributeVerificationCode" | "GetUserPoolMfaConfig" | "InitiateAuth" | "ListGroups" | "ListUserPoolClients" | "ListUserPools" | "ListUsers" | "ListUsersInGroup" | "RespondToAuthChallenge" | "RevokeToken" | "UpdateGroup" | "UpdateUserAttributes" | "UpdateUserPool" | "UpdateUserPoolClient";
