var __defProp = Object.defineProperty;
var __markAsModule = (target) => __defProp(target, "__esModule", { value: true });
var __export = (target, all) => {
  __markAsModule(target);
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
__export(exports, {
  appClientToResponseObject: () => appClientToResponseObject,
  groupToResponseObject: () => groupToResponseObject,
  userPoolToResponseObject: () => userPoolToResponseObject,
  userToResponseObject: () => userToResponseObject
});
const appClientToResponseObject = (appClient) => ({
  AccessTokenValidity: appClient.AccessTokenValidity,
  AllowedOAuthFlows: appClient.AllowedOAuthFlows,
  AllowedOAuthFlowsUserPoolClient: appClient.AllowedOAuthFlowsUserPoolClient,
  AllowedOAuthScopes: appClient.AllowedOAuthScopes,
  AnalyticsConfiguration: appClient.AnalyticsConfiguration,
  CallbackURLs: appClient.CallbackURLs,
  ClientId: appClient.ClientId,
  ClientName: appClient.ClientName,
  ClientSecret: appClient.ClientSecret,
  CreationDate: appClient.CreationDate,
  DefaultRedirectURI: appClient.DefaultRedirectURI,
  EnableTokenRevocation: appClient.EnableTokenRevocation,
  ExplicitAuthFlows: appClient.ExplicitAuthFlows,
  IdTokenValidity: appClient.IdTokenValidity,
  LastModifiedDate: appClient.LastModifiedDate,
  LogoutURLs: appClient.LogoutURLs,
  PreventUserExistenceErrors: appClient.PreventUserExistenceErrors,
  ReadAttributes: appClient.ReadAttributes,
  RefreshTokenValidity: appClient.RefreshTokenValidity,
  SupportedIdentityProviders: appClient.SupportedIdentityProviders,
  TokenValidityUnits: appClient.TokenValidityUnits,
  UserPoolId: appClient.UserPoolId,
  WriteAttributes: appClient.WriteAttributes
});
const userToResponseObject = (user) => ({
  Attributes: user.Attributes,
  Enabled: user.Enabled,
  MFAOptions: user.MFAOptions,
  UserCreateDate: user.UserCreateDate,
  UserLastModifiedDate: user.UserLastModifiedDate,
  Username: user.Username,
  UserStatus: user.UserStatus
});
const groupToResponseObject = (userPoolId) => (group) => ({
  CreationDate: group.CreationDate,
  Description: group.Description,
  GroupName: group.GroupName,
  LastModifiedDate: group.LastModifiedDate,
  Precedence: group.Precedence,
  RoleArn: group.RoleArn,
  UserPoolId: userPoolId
});
const userPoolToResponseObject = (userPool) => ({
  AccountRecoverySetting: userPool.AccountRecoverySetting,
  AdminCreateUserConfig: userPool.AdminCreateUserConfig,
  AliasAttributes: userPool.AliasAttributes,
  Arn: userPool.Arn,
  AutoVerifiedAttributes: userPool.AutoVerifiedAttributes,
  CreationDate: userPool.CreationDate,
  CustomDomain: userPool.CustomDomain,
  DeviceConfiguration: userPool.DeviceConfiguration,
  Domain: userPool.Domain,
  EmailConfiguration: userPool.EmailConfiguration,
  EmailConfigurationFailure: userPool.EmailConfigurationFailure,
  EmailVerificationMessage: userPool.EmailVerificationMessage,
  EmailVerificationSubject: userPool.EmailVerificationSubject,
  EstimatedNumberOfUsers: userPool.EstimatedNumberOfUsers,
  Id: userPool.Id,
  LambdaConfig: userPool.LambdaConfig,
  LastModifiedDate: userPool.LastModifiedDate,
  MfaConfiguration: userPool.MfaConfiguration,
  Name: userPool.Name,
  Policies: userPool.Policies,
  SchemaAttributes: userPool.SchemaAttributes,
  SmsAuthenticationMessage: userPool.SmsAuthenticationMessage,
  SmsConfiguration: userPool.SmsConfiguration,
  SmsConfigurationFailure: userPool.SmsConfigurationFailure,
  SmsVerificationMessage: userPool.SmsVerificationMessage,
  Status: userPool.Status,
  UsernameAttributes: userPool.UsernameAttributes,
  UsernameConfiguration: userPool.UsernameConfiguration,
  UserPoolAddOns: userPool.UserPoolAddOns,
  UserPoolTags: userPool.UserPoolTags,
  VerificationMessageTemplate: userPool.VerificationMessageTemplate
});
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  appClientToResponseObject,
  groupToResponseObject,
  userPoolToResponseObject,
  userToResponseObject
});
