export declare const Targets: {
    readonly AddCustomAttributes: ({ clock, cognito, }: {
        clock: import("../services").Clock;
        cognito: import("../services").CognitoService;
    }) => import("./addCustomAttributes").AddCustomAttributesTarget;
    readonly AdminAddUserToGroup: ({ cognito }: {
        cognito: import("../services").CognitoService;
    }) => import("./adminAddUserToGroup").AdminAddUserToGroupTarget;
    readonly AdminConfirmSignUp: ({ clock, cognito, triggers, }: {
        clock: import("../services").Clock;
        cognito: import("../services").CognitoService;
        triggers: import("../services").Triggers;
    }) => import("./adminConfirmSignUp").AdminConfirmSignUpTarget;
    readonly AdminCreateUser: ({ clock, cognito, messages, config, }: {
        clock: import("../services").Clock;
        config: import("../server/config").Config;
        cognito: import("../services").CognitoService;
        messages: import("../services").Messages;
    }) => import("./adminCreateUser").AdminCreateUserTarget;
    readonly AdminDeleteUser: ({ cognito }: {
        cognito: import("../services").CognitoService;
    }) => import("./adminDeleteUser").AdminDeleteUserTarget;
    readonly AdminDeleteUserAttributes: ({ clock, cognito, }: {
        clock: import("../services").Clock;
        cognito: import("../services").CognitoService;
    }) => import("./adminDeleteUserAttributes").AdminDeleteUserAttributesTarget;
    readonly AdminDisableUser: ({ cognito, clock }: {
        clock: import("../services").Clock;
        cognito: import("../services").CognitoService;
    }) => import("./adminDisableUser").AdminDisableUserTarget;
    readonly AdminEnableUser: ({ cognito, clock }: {
        clock: import("../services").Clock;
        cognito: import("../services").CognitoService;
    }) => import("./adminEnableUser").AdminEnableUserTarget;
    readonly AdminGetUser: ({ cognito }: {
        cognito: import("../services").CognitoService;
    }) => import("./adminGetUser").AdminGetUserTarget;
    readonly AdminInitiateAuth: (services: {
        cognito: import("../services").CognitoService;
        tokenGenerator: import("../services/tokenGenerator").TokenGenerator;
        triggers: import("../services").Triggers;
    }) => import("./adminInitiateAuth").AdminInitiateAuthTarget;
    readonly AdminListGroupsForUser: ({ cognito }: {
        cognito: import("../services").CognitoService;
    }) => import("./adminListGroupsForUser").AdminListGroupsForUserTarget;
    readonly AdminRemoveUserFromGroup: ({ cognito, }: {
        cognito: import("../services").CognitoService;
    }) => import("./adminRemoveUserFromGroup").AdminRemoveUserFromGroupTarget;
    readonly AdminSetUserPassword: ({ cognito, clock, }: {
        clock: import("../services").Clock;
        cognito: import("../services").CognitoService;
    }) => import("./adminSetUserPassword").AdminSetUserPasswordTarget;
    readonly AdminUpdateUserAttributes: ({ clock, cognito, otp, messages, }: {
        clock: import("../services").Clock;
        cognito: import("../services").CognitoService;
        messages: import("../services").Messages;
        otp: () => string;
    }) => import("./adminUpdateUserAttributes").AdminUpdateUserAttributesTarget;
    readonly ChangePassword: ({ cognito, clock }: {
        clock: import("../services").Clock;
        cognito: import("../services").CognitoService;
    }) => import("./changePassword").ChangePasswordTarget;
    readonly ConfirmForgotPassword: ({ cognito, clock, triggers, }: {
        clock: import("../services").Clock;
        cognito: import("../services").CognitoService;
        triggers: import("../services").Triggers;
    }) => import("./confirmForgotPassword").ConfirmForgotPasswordTarget;
    readonly ConfirmSignUp: ({ cognito, clock, triggers, }: Pick<import("../services").Services, "clock" | "cognito" | "triggers">) => import("./confirmSignUp").ConfirmSignUpTarget;
    readonly CreateGroup: ({ cognito, clock }: {
        clock: import("../services").Clock;
        cognito: import("../services").CognitoService;
    }) => import("./createGroup").CreateGroupTarget;
    readonly CreateUserPool: ({ cognito, clock }: {
        clock: import("../services").Clock;
        cognito: import("../services").CognitoService;
    }) => import("./createUserPool").CreateUserPoolTarget;
    readonly CreateUserPoolClient: ({ clock, cognito, }: {
        clock: import("../services").Clock;
        cognito: import("../services").CognitoService;
    }) => import("./createUserPoolClient").CreateUserPoolClientTarget;
    readonly DeleteGroup: ({ cognito }: {
        cognito: import("../services").CognitoService;
    }) => import("./deleteGroup").DeleteGroupTarget;
    readonly DeleteUser: ({ cognito }: {
        cognito: import("../services").CognitoService;
    }) => import("./deleteUser").DeleteUserTarget;
    readonly DeleteUserAttributes: ({ clock, cognito, }: {
        clock: import("../services").Clock;
        cognito: import("../services").CognitoService;
    }) => import("./deleteUserAttributes").DeleteUserAttributesTarget;
    readonly DeleteUserPool: ({ cognito }: {
        cognito: import("../services").CognitoService;
    }) => import("./deleteUserPool").DeleteUserPoolTarget;
    readonly DeleteUserPoolClient: ({ cognito }: {
        cognito: import("../services").CognitoService;
    }) => import("./deleteUserPoolClient").DeleteUserPoolClientTarget;
    readonly DescribeUserPool: ({ cognito }: Pick<import("../services").Services, "cognito">) => import("./describeUserPool").DescribeUserPoolTarget;
    readonly DescribeUserPoolClient: ({ cognito }: Pick<import("../services").Services, "cognito">) => import("./describeUserPoolClient").DescribeUserPoolClientTarget;
    readonly ForgotPassword: ({ cognito, clock, messages, otp, }: {
        clock: import("../services").Clock;
        cognito: import("../services").CognitoService;
        messages: import("../services").Messages;
        otp: () => string;
    }) => import("./forgotPassword").ForgotPasswordTarget;
    readonly GetGroup: ({ cognito }: Pick<import("../services").Services, "cognito">) => import("./getGroup").GetGroupTarget;
    readonly GetUser: ({ cognito }: Pick<import("../services").Services, "cognito">) => import("./getUser").GetUserTarget;
    readonly GetUserAttributeVerificationCode: ({ cognito, otp, messages, }: {
        cognito: import("../services").CognitoService;
        messages: import("../services").Messages;
        otp: () => string;
    }) => import("./getUserAttributeVerificationCode").GetUserAttributeVerificationCodeTarget;
    readonly GetUserPoolMfaConfig: ({ cognito }: {
        cognito: import("../services").CognitoService;
    }) => import("./getUserPoolMfaConfig").GetUserPoolMfaConfigTarget;
    readonly InitiateAuth: (services: {
        cognito: import("../services").CognitoService;
        messages: import("../services").Messages;
        otp: () => string;
        tokenGenerator: import("../services/tokenGenerator").TokenGenerator;
        triggers: import("../services").Triggers;
    }) => import("./initiateAuth").InitiateAuthTarget;
    readonly ListGroups: ({ cognito }: {
        cognito: import("../services").CognitoService;
    }) => import("./listGroups").ListGroupsTarget;
    readonly ListUserPoolClients: ({ cognito }: {
        cognito: import("../services").CognitoService;
    }) => import("./listUserPoolClients").ListUserPoolClientsTarget;
    readonly ListUserPools: ({ cognito }: {
        cognito: import("../services").CognitoService;
    }) => import("./listUserPools").ListUserPoolsTarget;
    readonly ListUsers: ({ cognito }: Pick<import("../services").Services, "cognito">) => import("./listUsers").ListUsersTarget;
    readonly ListUsersInGroup: ({ cognito }: Pick<import("../services").Services, "cognito">) => import("./listUsersInGroup").ListUsersInGroupTarget;
    readonly RespondToAuthChallenge: ({ clock, cognito, triggers, tokenGenerator, }: {
        clock: import("../services").Clock;
        cognito: import("../services").CognitoService;
        tokenGenerator: import("../services/tokenGenerator").TokenGenerator;
        triggers: import("../services").Triggers;
    }) => import("./respondToAuthChallenge").RespondToAuthChallengeTarget;
    readonly RevokeToken: ({ cognito }: {
        cognito: import("../services").CognitoService;
    }) => import("./revokeToken").RevokeTokenTarget;
    readonly SignUp: ({ clock, cognito, messages, otp, triggers, config, }: {
        clock: import("../services").Clock;
        config: import("../server/config").Config;
        cognito: import("../services").CognitoService;
        messages: import("../services").Messages;
        otp: () => string;
        triggers: import("../services").Triggers;
    }) => import("./signUp").SignUpTarget;
    readonly UpdateGroup: ({ clock, cognito }: {
        clock: import("../services").Clock;
        cognito: import("../services").CognitoService;
    }) => import("./updateGroup").UpdateGroupTarget;
    readonly UpdateUserAttributes: ({ clock, cognito, otp, messages, }: {
        clock: import("../services").Clock;
        cognito: import("../services").CognitoService;
        messages: import("../services").Messages;
        otp: () => string;
    }) => import("./updateUserAttributes").UpdateUserAttributesTarget;
    readonly UpdateUserPool: ({ cognito }: {
        cognito: import("../services").CognitoService;
    }) => import("./updateUserPool").UpdateUserPoolTarget;
    readonly UpdateUserPoolClient: ({ clock, cognito, }: {
        clock: import("../services").Clock;
        cognito: import("../services").CognitoService;
    }) => import("./updateUserPoolClient").UpdateUserPoolClientTarget;
    readonly VerifyUserAttribute: ({ clock, cognito, }: {
        clock: import("../services").Clock;
        cognito: import("../services").CognitoService;
    }) => import("./verifyUserAttribute").VerifyUserAttributeTarget;
};
